.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgtools::argvparse 0.2" "" "" "" ""
.hy
.PP
dgtools (dgtools.html) \- argvparse (argvparse.html) \-
recover (recover.html) \- repo (repo.html) \- shistory (shistory.html)
.SS NAME
.PP
\f[B]dgtools::argvparse\f[R] \- command line parsing package similar to
Pythons argparse library.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
TYPE OPTIONS
.IP \[bu] 2
TYPE COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
TEST
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require snit
package require dgtools::argvparse
namespace import ::dgtools::argvparse
argvparse cmdName options
cmdName cget option
cmdName configure option value
cmdName argument shortopt longopt description ?key ...?
cmdName parse argv
cmdName usage
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]dgtools::argvparse\f[R] \- is a snit type for parsing command line
arguments for Tcl applications in the spirit of Pythons argparse
library.
Parsing command line options for this package is a three step process.
First create the parser object with application specific options, like
application name and author, in the second step define one or more
arguments using the \f[I]argument\f[R] method for each option and at
last use the parse function for parsing the argv array.
## COMMAND
.PP
\f[B]dgtools::argvparse\f[R] \f[I]cmdName ?options?\f[R]
.RS
.PP
Creates and configures the \f[B]dgtools::argvparse\f[R] type using the
given command name and options.
.RE
.SS COMMAND OPTIONS
.PP
\f[B]\-appname\f[R] \f[I]string\f[R]
.RS
.PP
Will be used as the application name shown in the standard help page.
.RE
.PP
\f[B]\-author\f[R] \f[I]string\f[R]
.RS
.PP
Will be used as the author name shown in the standard help page.
.RE
.PP
\f[B]\-description\f[R] \f[I]string\f[R]
.RS
.PP
Will be used as description string shown in the standard help page.
.RE
.PP
\f[B]\-usage\f[R] \f[I]string\f[R]
.RS
.PP
Will be used as the usage string without the scriptname shown in the
standard help page.
.RE
.SS TYPE COMMANDS
.PP
The \f[B]argvparse\f[R] type supports the following commands to parse
command line arguments:
.PP
\f[I]cmdName\f[R] \f[B]argument\f[R] \f[I]shortopt longopt description
?key value \&...?\f[R]
.RS
.PP
Installs a command line option using the given short\- and longoption
flags and the option description.
The latter will be used in the standard help message.
The following key\-value pairs are supported:
.RE
.IP \[bu] 2
\f[I]\-boolean true|false\f[R] \- indication if this is a boolean flag.
.IP \[bu] 2
\f[I]\-default value\f[R] \- sets a default value if the argument is not
given on the command line.
.IP \[bu] 2
\f[I]\-required true|false\f[R] \- indication if this is a required
i.e.\ non\-optional argument.
.IP \[bu] 2
\f[I]\-script procname\f[R] \- the script to be executed if this option
is given on the command line.
The parsed argument list is appended as argument to the procedure
automatically.
.IP \[bu] 2
\f[I]\-type typename\f[R] \- the type of the argument, can be one of the
known types for the Tcl command \f[I]string is\f[R] such as integer,
ascii, boolean etc.
.PP
\f[I]cmdName\f[R] \f[B]cget\f[R] \f[I]option\f[R]
.RS
.PP
Retrieves the given option value for the argvparse type.
See options for a list of available options.
.RE
.PP
\f[I]cmdName\f[R] \f[B]configure\f[R] \f[I]option value ?option value
\&...?\f[R]
.RS
.PP
Configures the given option for the argvparse type.
See options for a list of available options.
.RE
.PP
\f[I]cmdName\f[R] \f[B]parse\f[R] \f[I]argv\f[R]
.RS
.PP
Does the actual parsing of the argv array.
Returns the parsing result as a key\-value list.
.RE
.PP
\f[I]cmdName\f[R] \f[B]usage\f[R] \f[I]?msg?\f[R]
.RS
.PP
Standard usage message for the terminal if the user did not provide the
correct command line arguments or if the user requests the help message
using either the with giving the short option \f[I]\-h\f[R] or the long
option \f[I]\[en]help\f[R].
.RE
.SS EXAMPLE
.IP
.nf
\f[C]
 package require dgtools::argvparse
 # simulate: tclsh script.tcl \-\-filename test.txt \-v 1 \-h
 # on the terminal by manually setting argv
 set argv [list \-\-filename test.txt \-v 1 \-h]
 proc mproc {args} {
    puts \[dq]proc mproc is executed with args $args\[dq]
 }
 set ap [::dgtools::argvparse %AUTO% \-appname \[dq]Test Application\[dq] \[rs]
         \-author \[dq]Detlef Groth\[dq] \-usage \[dq]\-f filename ?\-t \-m \-v number \-h?\[dq]]
 $ap argument \-f \-\-filename \[dq]filename (input file)\[dq] \-required true
 $ap argument \-t \-\-test \[dq](test flag)\[dq] \-boolean true 
 $ap argument \-m \-\-mproc \[dq](execute procedure mproc)\[dq] \-script mproc
 $ap argument \-v \-\-verbosity \[dq]number (specifying verbosity, values from 0 to 5)\[dq] \[rs]
                 \-type integer \-default 0
 set res [$ap parse $argv]
\f[R]
.fi
.PP
If this script is executed it gives the following help message:
.IP
.nf
\f[C]
===============================
Test Application \- Detlef Groth
===============================
Usage: argvparse.tcl \-f filename ?\-t \-m \-v number \-h?

Mandatory arguments:
 \-f, \-\-filename filename (input file)
Optional arguments:
 \-h, \-\-help (show this help page)
 \-m, \-\-mproc (execute procedure mproc)
 \-t, \-\-test (test flag)
 \-v, \-\-verbosity number (specifying verbosity, values from 0 to 5)
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy, you can install and use the
\f[B]dgtools::argvparse\f[R] package if you have a working install of:
.IP \[bu] 2
the snit package which can be found in tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgtools\f[R] folder into a
path of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgtools\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgtools/argvparse\-0.2.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of argvparse.tcl.
Try \[lq]tclsh argvparse.tcl \[en]install\[rq] for this purpose in the
terminal.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ tclsh argvparse.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ tclsh argvparse.tcl \-\-code
\f[R]
.fi
.SS TEST
.PP
Some tcltest\[cq]s are embedded in the source file as well, to run those
tests you should execute the following comamnd line:
.IP
.nf
\f[C]
$ tclsh argvparse.tcl \-\-test
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh argvparse.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh argvparse.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]argvparse.html\f[R] which
contains the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, a html or a pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh argvparse.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > argvparse.n
# html page
tclsh ../argvparse.tcl \-\-man > argvparse.md
pandoc \-i argvparse.md \-s \-o argvparse.html
# pdf
pandoc \-i argvparse.md \-s \-o argvparse.tex
pdflatex argvparse.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgtools \- package homepage
<http://chiselapp.com/user/dgroth/repository/tclcode/index>
.IP \[bu] 2
cmdline \- tcllib package for parsing of command line options n the
spirit of getopt
<https://core.tcl-lang.org/tcllib/doc/trunk/embedded/md/tcllib/files/modules/cmdline/cmdline.md>
.IP \[bu] 2
argparse \- parsing of procedure arguments in Tcl spirit
<https://wiki.tcl-lang.org/page/argparse>
.SS TODO
.IP \[bu] 2
more tests
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The \f[B]argvparse\f[R] snit type was written by Detlef Groth,
Schwielowsee, Germany.
.SS LICENSE AND COPYRIGHT
.PP
Command line parsing library dgtools::argvparse, version 0.2.
.PP
Copyright (c) 2019 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
