.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgtools::dgtutils 0.1" "" "" "" ""
.hy
.SS NAME
.PP
\f[B]dgtools::dgtutils\f[R] \- internal helper procedures for the
dgtools package
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMANDS
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgtools::dgtutils
dgtools::getVersion filename
dgtools::install filename
dgtools::manual mode filename
dgtools::runExample filename boolean
\f[R]
.fi
.SS DESCRIPTION
.PP
The \f[B]dgtools::dgtutils\f[R] package provide a few helper commands
for other packages in the \f[I]dgtools\f[R] package to format the
documentation, to extract the help pages and to show and run example
code embedded within the package documentation.
.PP
COMMANDS
.PP
\f[B]dgtools::getVersion\f[R] \f[I]filename\f[R]
.RS
.PP
Returns the package version of a given file.
Please note, that the package must have the same name as the file
basename.
.RE
.PP
\f[B]dgtools::install\f[R] \f[I]filename\f[R]
.RS
.PP
Installs the fiven file as Tcl module within the Tcl module path.
Please note, that the package must have the same name as the file
basename.
.RE
.PP
\f[B]dgtools::manual\f[R] \f[I]mode filename\f[R]
.RS
.PP
Extracts and formats the embedded documentation.
Option \f[I]mode\f[R] can bei either \f[I]\-html\f[R], \f[I]\-man\f[R]
or \f[I]\-markdown\f[R].
\-\f[I]man\f[R] is pandoc markdown, an extended version for the pandoc
document converter.
Documentation in Markdown must be prefix with a \f[C]#\[aq]\f[R] comment
sign.
.RE
.PP
\f[B]dgtools::runExample\f[R] \f[I]filename ?eval:boolean?\f[R]
.RS
.PP
Extracts and executes the code of the example section in the Markdown
formatted documentation.
Documentation must be prefixed with a \f[C]#\[aq]\f[R] comment indicator
and must be followed directly the example section header after two `##'
signs.
If the option eval is set to false the code is only returned.
.RE
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh recover.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to create a markdown document for
conversion into a markdown document that can be converted thereafter
into a html or pdf document.
If, for instance, you have pandoc installed you could execute the
following commands:
.IP
.nf
\f[C]
tclsh recover.tcl \-\-man > recover.md
pandoc \-i recover.md \-s \-o recover.html
pandoc \-i recover.md \-s \-o recover.tex
pdflatex recover.tex
\f[R]
.fi
.PP
Alternatively if the Markdown package of tcllib is available you can
convert the documentation as well directly to html using the
\f[I]\[en]html\f[R] flag:
.IP
.nf
\f[C]
$ tclsh recover.tcl \-\-html
\f[R]
.fi
.SS AUTHOR
.PP
The \f[B]dgtools::recover\f[R] command was written Detlef Groth,
Schwielowsee, Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2020 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgtools::dgtutils package 0.1 \- private procedures to be used within
the dgtools packages.
.PP
Copyright (c) 2020 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
