.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgtools::recover 0.1" "" "" "" ""
.hy
.PP
dgtools (dgtools.html) \- argvparse (argvparse.html) \-
recover (recover.html) \- repo (repo.html) \- shistory (shistory.html)
.SS NAME
.PP
\f[B]dgtools::recover\f[R] \- debugging command
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgtools::recover
dgtools::recover
dgtools::recover_onerror
dgtools::recover_stop
\f[R]
.fi
.SS DESCRIPTION
.PP
The \f[B]dgtools::recover\f[R] command allows to debug interactively
errors pr problems in Tcl terminal programs in the same spirit as the R
recover command.
.PP
COMMANDS
.PP
\f[B]dgtools::recover\f[R]
.RS
.PP
Manually jumps in debugging mode.
This command can be placed into critical code fragments and then you can
jump directly during debugging in this procedure.
See the following example:
.RE
.RS
.IP
.nf
\f[C]
proc test {x} {
set y $x
incr y
dgtools::recover
incr x
return $y
}
test 5
\f[R]
.fi
.RE
.PP
\f[B]dgtools::recover_onerror\f[R]
.RS
.PP
This replaces the error command, instead of reporting the error there
will be an interactive terminal where you can debug all variables in the
current procedure or method.
.RE
.PP
\f[B]dgtools::recover_stop\f[R]
.RS
.PP
This resets the error handling by the recover command to the normal
error command.
.RE
.SS EXAMPLE
.PP
The following example shows how you can jump into your own error calls
in your code.
As you normally report critical parts of your code with such error calls
it allows you to jump directly into those places and debug them.
Unfortunately, I don\[cq]t know how to jump automatically into the error
call of Tcl.
.IP
.nf
\f[C]
package require dgtools::recover
::dgtools::recover_onerror
proc test {x} {
  set y $x
  # the next line with the error 
  # will jump into the recover moce
  error \[dq]z does not exists\[dq]
  return $z
}
test 6
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh recover.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to create a markdown document for
conversion into a markdown document that can be converted thereafter
into a html or pdf document.
If, for instance, you have pandoc installed you could execute the
following commands:
.IP
.nf
\f[C]
tclsh recover.tcl \-\-man > recover.md
pandoc \-i recover.md \-s \-o recover.html
pandoc \-i recover.md \-s \-o recover.tex
pdflatex recover.tex
\f[R]
.fi
.PP
Alternatively if the Markdown package of tcllib is available you can
convert the documentation as well directly to html using the
\f[I]\[en]html\f[R] flag:
.IP
.nf
\f[C]
$ tclsh recover.tcl \-\-html
\f[R]
.fi
.SS AUTHOR
.PP
The \f[B]dgtools::recover\f[R] command was written Detlef Groth,
Schwielowsee, Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2020 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgtools:recover package \- debugging tool in spirit of R\[cq]s recover
function.
.PP
Copyright (c) 2020 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
