.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgtools::repo 0.1" "" "" "" ""
.hy
.PP
dgtools (dgtools.html) \- argvparse (argvparse.html) \-
recover (recover.html) \- repo (repo.html) \- shistory (shistory.html)
.SS NAME
.PP
\f[B]dgtools::repo\f[R] \- package and command line application for
installation of Tcl packages directly from github and chiselapp
repositories.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DEMO
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
SEE ALSO
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.PP
Usage as package:
.IP
.nf
\f[C]
package require tls
package require json
package require dgtools::repo
namespace import ::dgtools::repo
repo import github user repository folder
repo import chiselapp user repository folder
repo download github url folder
repo download chiselapp url folder
\f[R]
.fi
.PP
Usage as command line application:
.IP
.nf
\f[C]
tclsh repo.tcl \[dq]https://chiselapp.com/user/dgroth/repository/tclcode/dir?ci=c50f458ca23f7ae5&name=dgw\[dq] dgw
tclsh repo.tcl https://github.com/tcltk/tcllib/tree/master/modules/des
\f[R]
.fi
.SS DESCRIPTION
.PP
\f[B]dgtools::repo\f[R] \- is a package for directly downloading folders
and packages from github and chiselapp repositories.
I is useful if multiple packages are available within a certain
repository and the users only like to install one or a few of them.
Further a command line interface is available to download specific
directories from larger repositories.
## COMMAND
.PP
There are three sub commands available, \f[I]import\f[R] and
\f[I]update\f[R] should be used to retrieve tcl packages and install
them in a parallel directory to the actual script or the last directory
given in auto_path.
\f[I]download\f[R] downloads a specific subfolder of a directory.
.PP
\f[B]dgtools::repo\f[R] \f[I]provider cmd user repo directory\f[R]
.PP
Downloads and installs the given directory as a tcl package in parallel
to the actual script.
As package name the last part of the directory name is used.
The arguments are explained below:
.RS
.IP \[bu] 2
\f[I]provider\f[R]: either github or chiselapp currently
.IP \[bu] 2
\f[I]cmd\f[R]: either \f[C]import\f[R] which checks if the package was
already download and only if not installes it, or \f[C]update\f[R] which
will redo the download and possibly overwrite the current package.
.IP \[bu] 2
\f[I]user\f[R]: the user id of the repository maintainer such as
\[lq]tcltk\[rq] for example
.IP \[bu] 2
\f[I]repo\f[R]: the repository name such as \[lq]tcllib\[rq] for example
.IP \[bu] 2
\f[I]directory\f[R]: the relative folder within the repository such as
\[lq]modules/snit\[rq] for example
.RE
.PP
\f[B]dgtools::repo\f[R] \f[I]provider download url directory\f[R]
.PP
Downloads a specific (sub)folder from a repository of github or
chiselapp.
.RS
.IP \[bu] 2
\f[I]provider\f[R] either github or chiselapp
.IP \[bu] 2
\f[I]url\f[R] the url which is visible in standard view
.IP \[bu] 2
\f[I]directory\f[R] in which the repository folder should be stored
locally
.RE
.SS EXAMPLE
.PP
Below an example which install the snit package from tcllib and the dgw
package from the chiselapp tclcode repository of dgroth.
.IP
.nf
\f[C]
package require dgtools::repo
namespace import dgtool::repo
repo github import tcltk tcllib modules/snit
repo chiselapp import dgroth tclcode dgw
package require snit
package require dgw
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy, you can install and use the
\f[B]dgtools::repo\f[R] package if you have a working install of:
.IP \[bu] 2
the Tcl tls package and the json package from which can be found in
tcllib \-
https://core.tcl\-lang.org/tcllib (https://core.tcl-lang.org/tcllib)
.PP
For installation you copy the complete \f[I]dgtools\f[R] folder into a
path of your \f[I]auto_path\f[R] list of Tcl or you append the
\f[I]auto_path\f[R] list with the parent dir of the \f[I]dgtools\f[R]
directory.
Alternatively you can install the package as a Tcl module by creating a
file dgtools/repo\-0.1.tm in your Tcl module path.
The latter in many cases can be achieved by using the
\f[I]\[en]install\f[R] option of repo.tcl.
Try \[lq]tclsh repo.tcl \[en]install\[rq] for this purpose in the
terminal.
.SS DEMO
.PP
Example code for this package can be executed by running this file using
the following command line:
.IP
.nf
\f[C]
$ tclsh repo.tcl \-\-demo
\f[R]
.fi
.PP
The example code used for this demo can be seen in the terminal by using
the following command line:
.IP
.nf
\f[C]
$ tclsh repo.tcl \-\-code
\f[R]
.fi
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh repo.tcl \-\-markdown
\f[R]
.fi
.PP
This will extract the embedded manual pages in standard Markdown format.
You can as well use this markdown output directly to create html pages
for the documentation by using the \f[I]\[en]html\f[R] flag.
.IP
.nf
\f[C]
$ tclsh repo.tcl \-\-html
\f[R]
.fi
.PP
This will directly create a HTML page \f[C]repo.html\f[R] which contains
the formatted documentation.
Github\-Markdown can be extracted by using the \f[I]\[en]man\f[R]
switch:
.PP
The output of this command can be used to feed a markdown processor for
conversion into a man page, a html or a pdf document.
If you have pandoc installed for instance, you could execute the
following commands:
.IP
.nf
\f[C]
# man page
tclsh repo.tcl \-\-man | pandoc \-s \-f markdown \-t man \- > repo.n
# html page
tclsh ../repo.tcl \-\-man > repo.md
pandoc \-i repo.md \-s \-o repo.html
# pdf
pandoc \-i repo.md \-s \-o repo.tex
pdflatex repo.tex
\f[R]
.fi
.SS SEE ALSO
.IP \[bu] 2
dgw \- package homepage
<http://chiselapp.com/user/dgroth/repository/tclcode/index>
.SS TODO
.IP \[bu] 2
tests
.IP \[bu] 2
github repo as automatic copy of the chiselapp repo
.SS AUTHOR
.PP
The \f[B]dgtools::repo\f[R] package type was written by Detlef Groth,
Schwielowsee, Germany.
.SS LICENSE AND COPYRIGHT
.PP
package dgtools::repo, version 0.1.
.PP
Copyright (c) 2020 Dr.\ Detlef Groth, E\-mail: detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
