.\" Automatically generated by Pandoc 2.5
.\"
.TH "dgtools::shistory 0.2" "" "" "" ""
.hy
.PP
dgtools (dgtools.html) \- argvparse (argvparse.html) \-
recover (recover.html) \- repo (repo.html) \- shistory (shistory.html)
.SS NAME
.PP
\f[B]dgtools::shistory\f[R] \- a snit type history command.
.SS TABLE OF CONTENTS
.IP \[bu] 2
SYNOPSIS
.IP \[bu] 2
DESCRIPTION
.IP \[bu] 2
COMMAND
.IP \[bu] 2
TYPE OPTIONS
.IP \[bu] 2
TYPE COMMANDS
.IP \[bu] 2
EXAMPLE
.IP \[bu] 2
INSTALLATION
.IP \[bu] 2
DOCUMENTATION
.IP \[bu] 2
TODO
.IP \[bu] 2
AUTHOR
.IP \[bu] 2
COPYRIGHT
.IP \[bu] 2
LICENSE
.SS SYNOPSIS
.IP
.nf
\f[C]
package require dgtools::shistory
::dgtools::shistory cmd ?option value?
cmd back 
cmd canBackward
cmd canForward
cmd canFirst
cmd canLast
cmd cget option
cmd configure option value
cmd current
cmd first
cmd forward
cmd getHistory
cmd home
cmd insert value
cmd last
cmd resetHistory
\f[R]
.fi
.SS DESCRIPTION
.PP
The \f[B]shistory\f[R] type is data structure to allow the storage of
text strings in a history.
this can be useful to store for instance a browser history or a move
history in a board game like Chess or Go.
.SS TYPE OPTIONS
.PP
\f[B]\-home\f[R] value
.RS
.PP
The value which is set as the home, it is stored in principle as the
first item in the history.
Defaults to an empty string.
.RE
.SS TYPE COMMANDS
.PP
The \f[B]shistory\f[R] type supports a few commands to navigate in a
history list.
.PP
\f[I]cmd\f[R] \f[B]back\f[R]
.RS
.PP
Walks back in history one step and retrieves the value of the history at
this position.
.RE
.PP
\f[I]cmd\f[R] \f[B]canBackward\f[R]
.RS
.PP
Returns true if the current position in history is not the first value
in history and if the length of history is greater than 1.
.RE
.PP
\f[I]cmd\f[R] \f[B]canFirst\f[R]
.RS
.PP
Returns true if the current position in history is not the first value
in history and if history length is greater than 1.
.RE
.PP
\f[I]cmd\f[R] \f[B]canForward\f[R]
.RS
.PP
Returns true if the current position in history is not the last value in
history.
.RE
.PP
\f[I]cmd\f[R] \f[B]canLast\f[R]
.RS
.PP
Returns true if the current position in history is not the last value in
history.
.RE
.PP
\f[I]cmd\f[R] \f[B]cget\f[R] \f[I]option\f[R]
.RS
.PP
Retrieves the given option value for the shistory type.
Curently only the \f[I]\-home\f[R] option is available for
\f[I]cget\f[R].
.RE
.PP
\f[I]cmd\f[R] \f[B]configure\f[R] \f[I]option value ?option value
\&...?\f[R]
.RS
.PP
Configures the given option for the shistory type.
Curently only the \f[I]\-home\f[R] option is available for
\f[I]configure\f[R].
.RE
.PP
\f[I]cmd\f[R] \f[B]current\f[R]
.RS
.PP
Retrieves the current value of the history.
.RE
.PP
\f[I]cmd\f[R] \f[B]first\f[R]
.RS
.PP
Jumps to the first entry in history and returns it.
.RE
.PP
\f[I]cmd\f[R] \f[B]forward\f[R]
.RS
.PP
Gos one step forward in history and returns the value there.
.RE
.PP
\f[I]cmd\f[R] \f[B]getHistory\f[R]
.RS
.PP
Returns the history, a list of text entries.
.RE
.PP
\f[I]cmd\f[R] \f[B]insert\f[R] \f[I]value\f[R]
.RS
.PP
Inserts the value in the history at the actual index.
.RE
.PP
\f[I]cmd\f[R] \f[B]home\f[R]
.RS
.PP
Returns the home index value which was set using the \f[I]\-home\f[R]
option.
.RE
.PP
\f[I]cmd\f[R] \f[B]last\f[R]
.RS
.PP
Jumps to the last value in history and returns the value there.
.RE
.SS EXAMPLE
.IP
.nf
\f[C]
 package require dgtools::shistory
 set sh [::dgtools::shistory %AUTO% \-home h]
 $sh insert a
 $sh insert a ;# should not give duplicates
 $sh insert a
 $sh insert b
 puts \[dq]\[rs]ncanback: [$sh canBackward]\[dq]
 puts \[dq]canforw: [$sh canForward]\[dq]
 $sh back
 $sh insert z
 puts [$sh getHistory]
 puts [$sh home]
 puts \[dq]last: [$sh last]\[dq]
\f[R]
.fi
.SS INSTALLATION
.PP
Installation is easy, you can install and use this
\f[B]dgtools::shistory\f[R] package if you have a working install of the
snit package which can be found in
tcllib (https://core.tcl-lang.org/tcllib/doc/trunk/embedded/index.md).
To use the \f[B]dgtools::shistory\f[R] package then, you can either
sourc it within your Tcl\-code:
\f[C]source /path/to/dgtools/shistory.tcl\f[R], or by copying the folder
\f[I]dgtools\f[R] to a path belonging to your Tcl \f[C]$auto_path\f[R]
variable or by installing it as an Tcl\-module.
To do this, make either yourself a copy of \f[C]shistory.tcl\f[R] to a
file like \f[C]shistory\-0.1.tm\f[R] and put this file into a folder
named \f[C]dgtools\f[R] where the parent folder belongs to your module
path.
You must eventually adapt your Tcl\-module path by using in your Tcl
code the command: \f[C]tcl::tm::path add /parent/dir/\f[R] of the
\f[C]dgtools\f[R] directory.
For details of the latter consult see the manual page of
tcl::tm (https://www.tcl.tk/man/tcl/TclCmd/tm.htm).
.PP
Alternatively there is an install option you can use as well.
Try \f[C]tclsh shistory.tcl \-\-install\f[R] which should perform the
procedure described above automatically.
This requires eventually the setting of an environment variables if you
have no write access to all of your module paths.
For instance on my computer I have the following entry in my
\f[C].bashrc\f[R]
.IP
.nf
\f[C]
export TCL8_6_TM_PATH=/home/groth/.local/lib/tcl8.6
\f[R]
.fi
.PP
If I execute \f[C]tclsh shistory.tcl \-\-install\f[R] the file
\f[C]shistory.tcl\f[R] will be copied to
\f[C]/home/groth/.local/lib/tcl8.6/dgtools/shistory\-0.1.tm\f[R] and is
thereafter available for a \f[C]package require dgtools::shistory\f[R].
.SS DOCUMENTATION
.PP
The script contains embedded the documentation in Markdown format.
To extract the documentation you should use the following command line:
.IP
.nf
\f[C]
$ tclsh shistory.tcl \-\-man
\f[R]
.fi
.PP
The output of this command can be used to create a markdown document for
conversion into a markdown document that can be converted thereafter
into a html or pdf document.
If, for instance, you have pandoc installed you could execute the
following commands:
.IP
.nf
\f[C]
tclsh ../shistory.tcl \-\-man > shistory.md
pandoc \-i shistory.md \-s \-o shistory.html
pandoc \-i shistory.md \-s \-o shistory.tex
pdflatex shistory.tex
\f[R]
.fi
.SS TODO
.IP \[bu] 2
probably as usually more documentation
.IP \[bu] 2
github url for putting the code
.SS AUTHOR
.PP
The \f[B]shistory\f[R] snit type was written Detlef Groth, Schwielowsee,
Germany.
.SS COPYRIGHT
.PP
Copyright (c) 2019\-20 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.SS LICENSE
.PP
dgtools:shistory package \- data structure, a list of text entries which
can be navigated as history, version 0.2.
.PP
Copyright (c) 2019\-20 Dr.\ Detlef Groth, E\-mail:
detlef(at)dgroth(dot)de
.PP
This library is free software; you can use, modify, and redistribute it
for any purpose, provided that existing copyright notices are retained
in all copies and that this notice is included verbatim in any
distributions.
.PP
This software is distributed WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
.SH AUTHORS
Detlef Groth, Schwielowsee, Germany.
